#   put the command line args into vars
$target_drive = shift(@ARGV);
$machine_name = shift(@ARGV);
$machine_desc = shift(@ARGV);
$machine_numb = shift(@ARGV);

print"\n\n";

#   check that the target drive is local
if($target_drive eq "c:") {
    print("Target Drive is ", $target_drive, " (local).\n");
    $bad_drive = "T";
}
if($target_drive eq "C:") {
    print("Target Drive is ", $target_drive, " (local).\n");
    $bad_drive = "T";
}
if($target_drive eq "d:") {
    print("Target Drive is ", $target_drive, " (local).\n");
    $bad_drive = "T";
}
if($target_drive eq "D:") {
    print("Target Drive is ", $target_drive, " (local).\n");
    $bad_drive = "T";
}
if($target_drive eq "e:") {
    print("Target Drive is ", $target_drive, " (local).\n");
    $bad_drive = "T";
}
if($target_drive eq "E:") {
    print("Target Drive is ", $target_drive, " (local).\n");
    $bad_drive = "T";
}
if($bad_drive ne "T"){
    print("Target drive ", $target_drive, " is not local or contains a specific path.\n");
    print("You must specify a local drive (c:, d:, or e:)\n\n");
    &eediot;
}

#   check that the machine_name is <= 12 chars long
if(length($machine_name) > 12) {
    print("Machine Name: ", $machine_name, " is longer than 12 characters.\n\n");
    &eediot;
}else{
    print("Machine Name is ", $machine_name, ".\n");
}

#   check that the machine_desc is <=20 chars long
if(length($machine_desc) > 20) {
    print("Machine Description: ", $machine_desc, " is longer than 20 characters.\n\n");
    &eediot;
}else{
    print("Machine Description is ", $machine_desc, ".\n");
}

#   check that the machine_numb is 4 chars long
if(length($machine_numb) != 4) {
    print("Machine ID Number: ", $machine_numb, " is not 4 characters long.\n");
    &eediot;
}else{
#   check that the machine_numb is unique (not already used)
    print "Checking ID number: $machine_numb.";
    open(ID_FILE, "R:slave_id.lst") || die "Can't open R:slave_id.lst\n";
    while (<ID_FILE>) {
        print ".";
        if (/^$machine_numb/) {
            print("ID number $machine_numb already in use by:\n");
            print;
            &eediot;
            last;
        }
    }
    close(ID_FILE);
}


#   did all of the args evaluate to valid values ?
if($bad_args eq "T"){
    print"\n!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\n";
    print"One or more invalid arguments.\nTry again or call Bill McAdams.\n";
    print"!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\n";
    print"    usage:  3ds3inst <target> <name & number> <machine description> <ID number>\n";
    print"  example:  3ds3inst    c:      bdmcadam4597   mcadams_33m_32mb         0042\n";
    print"                        ^^      ^^^^^^^^^^^^   ^^^^^^^^^^^^^^^^         ^^^^\n";
    print"                                                                     \n";
    print"install on local drive                                             \n";
    print"                                                                      \n";
    print"login ID + phone (12 chars max)                                      \n";
    print"                                                                       \n";
    print"machine description (20 chars max)                        \n";
    print"Please include your name,                                               \n";
    print"processor speed and amount of RAM                                       \n";
    print"                                                                        \n";
    print"A 4 digit number between 0000 and 9999\n";
    print"This will be checked for uniqueness.\n";
}else{
#Inform user that the ID is acceptable.
    print "\n-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+\n";
    print "$machine_numb  $machine_name  $machine_desc\n";
    print "-+-+-+-+-+-+-+ Accepted -+-+-+-+-+-+-+-+\n";
#unzip 3ds3
    $dos_cmd_002 = "pkunzip -do r:3ds3 *.* $target_drive";
#    system"$ENV{'COMSPEC'} /c $dos_cmd_002" || die "Unable to run PKUNZIP.\n";
#update the slave list
    print "Updating slave_id.lst.";
    open(ID_FILE, "R:slave_id.lst") || die "Can't open R:slave_id.lst for reading.\n";
    open(ID_SPAWN, ">R:slave_id.new") || die "Can't open slave_id.new for writing.\n";
    while(<ID_FILE>) {
        print ID_SPAWN;
        print ".";
    }
    print ID_SPAWN "$machine_numb  $machine_name  $machine_desc\n";
    close(ID_FILE);
    close(ID_SPAWN);
    $dos_cmd_000 = "copy r:slave_id.new r:slave_id.lst > nul";
    $dos_cmd_001 = "del r:slave_id.new";
    system"$ENV{'COMSPEC'} /c $dos_cmd_000" || die "Unable to copy slave_id.new to slave_id.lst.\n";
    print ".";
    system"$ENV{'COMSPEC'} /c $dos_cmd_001" || die "Unable to delete slave_id.new.\n";
#update local master.set
    print ".\nUpdating local MASTER.SET";
    $dos_cmd_100 = "c:";
    $dos_cmd_101 = "cd\\3ds3";
    system"$ENV{'COMSPEC'} /c $dos_cmd_100";
    system"$ENV{'COMSPEC'} /c $dos_cmd_101";
#    $file_master = ($target_drive. "\\3ds3\\master.set");
    $file_master = ("master.set");
#    $file_spawn = ($target_drive. ">\\3ds3\\master.new");
    $file_spawn = (">master.new");
    open(MASTER,$file_master) || die "Unable to open $file_master\n";
    open(SPAWN,$file_spawn) || die "Unable to open $file_spawn for writing\n";
    while (<MASTER>) {
        $wrote_one = "nil";
        if(/^NET-OWNER =/) {
        $wrt_str = "NET-OWNER = \x22".$machine_name."\x22\n";
        $wrote_one = "T";
        print SPAWN $wrt_str;
        }
        if(/^NET-NAME =/) {
        $wrt_str = "NET-NAME = \x22".$machine_desc."\x22\n";
        $wrote_one = "T";
        print SPAWN $wrt_str;
        }
        if(/^NET-MACHINE-ID =/) {
        $wrt_str = "NET-MACHINE-ID = ".$machine_numb."\n";
        $wrote_one = "T";
        print SPAWN $wrt_str;
        }
        if(/^NET-MACHINE-TYPE =/) {
        $wrt_str = "NET-MACHINE-TYPE = OFF\n";
        $wrote_one = "T";
        print SPAWN $wrt_str;
        }
        if($wrote_one eq "nil"){
            print(SPAWN);
        }
    }
    close(MASTER);
    close(SPAWN);
#update local slave.set
    print ".\nUpdating local SLAVE.SET";
#    $file_slave = ($target_drive. "\\3ds3\\slave.set");
#    $file_spawn = ($target_drive. ">\\3ds3\\slave.new");
    $file_slave = ("slave.set");
    $file_spawn = (">slave.new");
    open(SLAVE,$file_master) || die "Unable to open $file_slave\n";
    open(SPAWN,$file_spawn) || die "Unable to open $file_spawn for writing\n";
    while (<SLAVE>) {
        $wrote_one = "nil";
        if(/^NET-OWNER =/) {
        $wrt_str = "NET-OWNER = \x22".$machine_name."\x22\n";
        $wrote_one = "T";
        print SPAWN $wrt_str;
        }
        if(/^NET-NAME =/) {
        $wrt_str = "NET-NAME = \x22".$machine_desc."\x22\n";
        $wrote_one = "T";
        print SPAWN $wrt_str;
        }
        if(/^NET-MACHINE-ID =/) {
        $wrt_str = "NET-MACHINE-ID = ".$machine_numb."\n";
        $wrote_one = "T";
        print SPAWN $wrt_str;
        }
        if(/^NET-MACHINE-TYPE =/) {
        $wrt_str = "NET-MACHINE-TYPE = SLAVE\n";
        $wrote_one = "T";
        print SPAWN $wrt_str;
        }
        if($wrote_one eq "nil"){
            print(SPAWN);
        }
    }
    close(SLAVE);
    close(SPAWN);
    $dos_cmd_200 = "copy master.new master.set";
    $dos_cmd_201 = "copy slave.new slave.set";
    $dos_cmd_203 = "del master.new";
    $dos_cmd_204 = "del slave.new";
    system"$ENV{'COMSPEC'} /c $dos_cmd_200";
    system"$ENV{'COMSPEC'} /c $dos_cmd_201";
    system"$ENV{'COMSPEC'} /c $dos_cmd_202";
    system"$ENV{'COMSPEC'} /c $dos_cmd_203";
    print "\n\n-------------------------------------\n";
    print "         Installation complete\n";
    print "  Before starting 3ds3, cd to the 3ds3 directory on your local drive.";
    print "     To start 3ds3 as a workstation, type MASTER\n";
    print "     To start 3ds3 as a slave, type SLAVE.\n\n";
    print "  It would be sporting of you to leave it running as a slave\n";
    print "  each night when you go home.\n";
}

sub eediot {
    $bad_args = "T";
}
